#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>


using namespace std;



struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data(istream& in, bool prompt) {

    size_t number_count;
    if (prompt){
        cerr << "Enter number count: ";
    }
    in >> number_count;

    Input on;

    if (prompt){
        cerr << "Enter bin count: ";
    }
    in >> on.bin_count;

    on.numbers.resize(number_count);

    if (prompt){
        cerr << "Enter numbers: ";
    }
    for (size_t i = 0; i < number_count; i++) {
        in >> on.numbers[i];
    }
    return on;
};

int main( int argc, char* argv[]){
    if (argc > 1){
        CURL* curl = curl_easy_init();
        if(curl) {
            CURLcode res;
            curl_easy_setopt(curl, CURLOPT_URL, argv[0]);
            res = curl_easy_perform(curl);
            if(res != CURLE_OK){
                fprintf(stderr, "curl_easy_perform() failed: %s\n",
                curl_easy_strerror(res));
                exit(1);
            }
            curl_easy_cleanup(curl);
        }
        return 0;
    }

    curl_global_init(CURL_GLOBAL_ALL);

    bool prompt = true;
    auto in = input_data(cin, prompt);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins, in.bin_count);
    show_histogram_svg(bins);
    return 0;
}

